package stamp.core;

public class PROP {
  /**
   * A constant representing pin P0.
   */
  public final static int pin0  = 1<<0;
  /**
   * A constant representing pin P1.
   */
  public final static int pin1  = 1<<1;
  /**
   * A constant representing pin P2.
   */
  public final static int pin2  = 1<<2;
  /**
   * A constant representing pin P3.
   */
  public final static int pin3  = 1<<3;
  /**
   * A constant representing pin P4.
   */
  public final static int pin4  = 1<<4;
  /**
   * A constant representing pin P5.
   */
  public final static int pin5  = 1<<5;
  /**
   * A constant representing pin P6.
   */
  public final static int pin6  = 1<<6;
  /**
   * A constant representing pin P7.
   */
  public final static int pin7  = 1<<7;
  /**
   * A constant representing pin P8.
   */
  public final static int pin8  = (1<<0)+256;
  /**
   * A constant representing pin P9.
   */
  public final static int pin9  = (1<<1)+256;
  /**
   * A constant representing pin P10.
   */
  public final static int pin10 = (1<<2)+256;
  /**
   * A constant representing pin P11.
   */
  public final static int pin11 = (1<<3)+256;
  /**
   * A constant representing pin P12.
   */
  public final static int pin12 = (1<<4)+256;
  /**
   * A constant representing pin P13.
   */
  public final static int pin13 = (1<<5)+256;
  /**
   * A constant representing pin P14.
   */
  public final static int pin14 = (1<<6)+256;
  /**
   * A constant representing pin P15.
   */
  public final static int pin15 = (1<<7)+256;
  /**
   * A constant representing pin P16.
   */
  public final static int pin16 = (1<<0)+512; //stampSOUT serial out (pin 1 of spin stamp)
  /**
   * A constant representing pin P17.
   */
  public final static int pin17 = (1<<1)+512; //stampSIN serial in  (pin 2 of spin stamp)
  /**
   * A constant representing pin P18.
   */
  public final static int pin18 = (1<<2)+512; //stampATN digital in (pin 3 of spin stamp)
  /**
   * A constant representing pin P19.
   */
  public final static int pin19 = (1<<3)+512;
  /**
   * A constant representing pin P20.
   */
  public final static int pin20 = (1<<4)+512;
  /**
   * A constant representing pin P21.
   */
  public final static int pin21 = (1<<5)+512;
  /**
   * A constant representing pin P22.
   */
  public final static int pin22 = (1<<6)+512;
  /**
   * A constant representing pin P23.
   */
  public final static int pin23 = (1<<7)+512;
  /**
   * A constant representing pin P24.
   */
  public final static int pin24 = (1<<0)+768;
  /**
   * A constant representing pin P25.
   */
  public final static int pin25 = (1<<1)+768;
  /**
   * A constant representing pin P26.
   */
  public final static int pin26 = (1<<2)+768;
  /**
   * A constant representing pin P27.
   */
  public final static int pin27 = (1<<3)+768;
  /**
   * A constant representing pin P28.
   */
  public final static int pin28 = (1<<4)+768; //propSCL external eeprom SCL
  /**
   * A constant representing pin P29.
   */
  public final static int pin29 = (1<<5)+768; //propSDA external eeprom SDA
  /**
   * A constant representing pin P30.
   */
  public final static int pin30 = (1<<6)+768; //propTX programming output
  /**
   * A constant representing pin P31.
   */
  public final static int pin31 = (1<<7)+768; //propRX programming input

  /**
   * An array representing all of the pins on the module. The nth element of the
   * array refers to the nth pin. i.e. PROP.pins[5] == PROP.pin5
   */
  public static int pins[] = {PROP.pin0, PROP.pin1, PROP.pin2, PROP.pin3,
                              PROP.pin4, PROP.pin5, PROP.pin6, PROP.pin7,
                              PROP.pin8, PROP.pin9, PROP.pin10,PROP.pin11,
                              PROP.pin12,PROP.pin13,PROP.pin14,PROP.pin15,
                              PROP.pin16,PROP.pin17,PROP.pin18,PROP.pin19,
                              PROP.pin20,PROP.pin21,PROP.pin22,PROP.pin23,
                              PROP.pin24,PROP.pin25,PROP.pin26,PROP.pin27,
                              PROP.pin28,PROP.pin29,PROP.pin30,PROP.pin31};

  /**
   * A constant representing the first I/O port on the Propeller. This port
   * contains pins 0-7.
   */
  public final static int PORTA = 0x00FF;

  /**
   * A constant representing the second I/O port on the Propeller. This port
   * contains pins 8-15.
   */
  public final static int PORTB = 0x01FF;

  /**
   * A constant representing the first I/O port on the Propeller. This port
   * contains pins 16-23.
   */
  public final static int PORTC = 0x02FF;

  /**
   * A constant representing the second I/O port on the Propeller. This port
   * contains pins 24-31.
   */
  public final static int PORTD = 0x03FF;

}

